#include<iostream.h>
#include<stdio.h>
#include"mydefs.h"


class Rat {
   int z;
   u_int n;

public:

   Rat(int a=0,u_int b=1): z(a), n(b)
   { 
     n || cerr<<"rational with zero denominator changed to "<<(n=1)<<endl;
     reduce();
   }

   Rat(char *s)
   { Rat r;

     switch(sscanf(s,"%d%*[ /]%u",&(r.z),&(r.n)))
     { case 0:
	 cerr<<"no correct string `"<<s<<"' "<<endl;
	 r=1;
       CASE 1:
	 r.n=1;
     }

     *this=r;

   }


   Rat operator +(const Rat& r) { return Rat(z*r.n+n*r.z,r.n*n); }
   Rat operator -(const Rat& r) { return Rat(z*r.n-n*r.z,r.n*n); }
   Rat operator -() { return Rat(-z,n); }
   Rat operator *(const Rat& r) { return Rat(z*r.z,r.n*n); }
   Rat operator /(const Rat& r) { 
			// cout<<"("<<sgn(r.z*(int)n)<<","<<z*r.n<<","<<abs(r.z*(int)n)<<")"<<endl;
			return Rat(sgn(r.z*(int)n)*z*r.n,abs(r.z*(int)n)); }
   Rat operator /(const int&i) { ret (*this)/Rat(i); }
   Rat& operator *=(const Rat& r) { return *this=*this*r; }
   Rat& operator +=(const Rat& r) { return *this=*this+r; }

   bool operator==(const Rat& r) { return z*r.n==n*r.z; }
   bool operator!=(const Rat& r) { return !(*this==r); }

   operator double(){ return ((double) z)/n; }
   operator int(){ return z/(int)n; }

   friend ostream & operator<<(ostream & o,const Rat& r)
   { o<<" "<<r.z;
     return r.n>1 ? o<<"/"<<r.n<<" " : o<<" "; 
   }

   friend Rat oper *(int k,Rat r) { ret Rat(k)*r; }

   Rat reduce()
   { 
     z ||(n=1);

     for(int i=2;i<=min((u_int)abs(z),n);i++) 
              z%i||n%i||(z/=i,n/=i--);

     return *this;
   }
};

typedef Rat Rational;



