#include<stdio.h>
#include<iostream.h>
#include<stream.h>
#include<fstream.h>
#include<math.h>


class comp {

double real,imag;
public:

  comp(double r=0,double i=0): real(r), imag(i) {}
  comp(const comp & i): real(i.real), imag(i.imag) {}
  friend double & SetRe(comp & z) { return z.real; }
  friend double & SetIm(comp & z) { return z.imag; }
  friend double Re(comp const & z) { return z.real; }
  friend double Im(comp const & z) { return z.imag; }

  comp operator +(const comp& s) const { return comp(real+Re(s),imag+Im(s)); }
  comp operator -() const { return comp(-real,-imag); }
  comp operator -(const comp& s) const { return  *this+(-s); }
  comp operator *(const comp& s) const { return comp(real*Re(s)-imag*Im(s),
					imag*Re(s)+real*Im(s)); }
  friend double norm2(const comp& z) { return Re(z)*Re(z)+Im(z)*Im(z); }
  friend double norm(const comp& z) { return sqrt(norm2(z)); }
  friend comp operator *(double s,const comp& t)
    { return comp(Re(t)*s,Im(t)*s); }
  friend ostream & operator <<(ostream & o,const comp& s)
    { return o<<Im(s)<<" + "<<Re(s)<<" i ";
      // Re(s)<<" + "<<Im(s)<<" i "; 
      // form("%lf + %lf i ",Re(s),Im(s),o); 
      //o<<Re(s)<<" + "<<Im(s)<<" i ";
    }
  friend istream & operator >>(istream & i,comp& s)
  {
    
     if(!(i>>s.real)) cerr<<"format error"<<endl;
     char f;
     if(i>>s.imag) i>>f;

     if(f!='I') cerr<<"format error"<<endl;

     ret i;
  }

  comp operator /(double s) const { return comp(real/s,imag/s); }
  comp operator !() const { return comp(real,-imag); }
  // complex conjugation
  comp operator /(const comp& s) const { return (*this* !s )/norm2(s); }
  bool operator ==(comp s) { return norm2(*this-s)<0.0001; }
  // hope we don't need it
  bool operator !=(comp s) { return !((*this)==s); }
  operator bool () { return (*this)!=comp(0); }
  comp operator +=(const comp& s) { return *this=*this+s; }
  comp operator -=(const comp& s) { return *this=*this-s; }
  comp operator /=(const comp& s) { return *this=*this/s; }
  comp operator *=(const comp& s) { return *this=*this*s; }

} I(0,1);
