#ifndef MY_DEFS
#define MY_DEFS

#include<sys/types.h>
#include<string.h>
#include<malloc.h>
#include<iostream.h>
#include <fstream.h>
#include <stream.h>
#include <stdio.h>


#define CASE break;case
#define DEFL break;default
#define loop while(1)
#define ret return
#define oper operator
#define cont continue

#ifdef NOTRC
#define TRC(a) (mycerr<<"line "<< __LINE__<< ": " #a "=" << (a) << endl)
#define TRCA(a,b) (mycerr<<"line "<< __LINE__<< ": {" #a "," #b "} =" , outputarray(mycerr,a,b))
ofstream mycerr("/dev/null",ios::out);
#else
#define TRC(a) (TRC_FLAG?cerr<< "line " << __LINE__ << ": " #a "=" << (a) << endl:cerr)
#define TRCA(a,b) (TRC_FLAG?(cerr<<"line "<< __LINE__<< ": {" #a "," #b "} =" , outputarray(cerr,a,b),cerr):cerr)
#endif

int TRC_FLAG=1;

typedef u_short u_sh;
typedef short sh;

inline char *STRDUP(const char *y) { return (char *)y?strdup(y):(char *)0; }

class string {
  char *s;
  public:
    string(u_sh l=0): s(new char[l]) {}
    string(const char *y): s(STRDUP(y)) {}
    ~string() { delete [] s; }
    string(const string & y): s(STRDUP(y.s)) {}
    string & operator =(const string & y) { 
      // cout<<"bla\n";
      delete [] s;
      s=STRDUP(y.s);
      return *this;
    }
    operator char * () const { return s; }
    operator bool () const { return s!=0; }
    bool operator ==(const char *s) { return strcmp((char *)(*this),s)==0; }
    bool operator !=(const char *s) { return !(*this==s); }
    u_sh len() const { return strlen(*this); }
    string operator +(const string k) const {
      string h(len()+k.len()+1);
      strcpy((char *)h,*this); strcat((char *)h,k); return h; 
    }
    string operator +(const char *k) const { return *this+string(k); }
    string & operator +=(string k) { return *this=*this+k; }
    string & operator +=(const char *k) { return *this=*this+k; }
    friend string operator +(const char *k,const  string s) { return string(k)+s; }
    friend ostream & operator <<(ostream & o, string y) { return o<<y.s; }

    char & operator [](u_sh k) { return s[k]; }
};

string tostr(int l) { int i,k; for(i=2,k=l;k/=10;i++); string s(i);
       sprintf(s,"%d",l); ret s; }

// inline bool operator ==(string a,char *b) { return strcmp(a,b)==0; }

// #ifndef _STDLIB_H

template<class C>
inline C abs(const C a) { return a*sgn(a); }

// #endif

template<class C>
// ACHTUNG: das wurde geaendert: frueher war `a<0?-1:1'
// ev. Fehlerquelle !!!
inline sh sgn(const C a) { return a<0?-1:a>0?1:0; }

template<class C>
inline char cmp(const C a,const C b) { 
  // cout<<"cmp("<<a<<","<<b<<");"<<endl;
  
  return a<b?-1:a>b?1:0; }

template<class C>
inline C min(const C a,const C b) { return a<b?a:b; }

// template<class C>
// inline C min(C a,C b) { return a<b?a:b; }

template<class C>
inline C max(const C a,const C b) { return a>b?a:b; }

// template<class C>
// inline C max(C a,C b) { return a>b?a:b; }

template<class C>
inline void swap(C & c1,C & c2) { C a=c1; c1=c2; c2=a; }

template<class C>
inline C* reverse(C* s, u_sh l)
{ C* g=new C[l];

  for(u_sh y=0;y<l;y++) g[y]=s[l-1-y];  
  
  return g; 
}

template<class C>
inline ostream & outputarray(ostream &o,C const *  a, u_int j, char *st="{",char *sep=",",char *end="}") {
  for(u_int i=0;i<j;i++) o<<(i?sep:st)<<a[i];
  ret o<<end<<endl;
}

template<class C>
inline ostream & varoutputarray(ostream &o,C const *  a, u_int j,
char *st="{",char *sep=",",char *end="}")
{
  for(u_int i=0;i<j;i++) o<<(i?sep:st)<<a[i];
  ret o<<end;
}

/*
template<class C>
inline ostream & outputarray(ostream &o,C const *  a, u_int j)
{
  for(u_int i=0;i<j;i++) o<<(i?",":"}")<<a[i];
  ret o<<"}"<<endl;
}
*/

template<class C>
inline istream & readarray(istream & i,C * & a, u_int j,
char st='{',char sep=',',char end='}')
{ 
  C *ar=a?a:new C[j];
  char c;

   for(u_sh k=0;k<j;k++)
   { 
          if((int)(k?sep:st)) while(i>>c && c!=(k?sep:st)); 
	  i>>ar[k];
   }
	  
   if((int)end) while(i>>c && c!=end);
   a=ar;

   ret i;
}


template<class C>
inline istream & inputarray(istream & i,C * & a, u_int & j,
char st='{',char sep=',',char end='}')
{ 
  i>>j;
	    
  C *ar=a?a:new C[j];
  char c;

   for(u_sh k=0;k<j;k++)
   { 
          if((int)(k?sep:st)) while(i>>c && c!=(k?sep:st)); 
	  i>>ar[k];
   }
	  
   if((int)end) while(i>>c && c!=end);
   a=ar;

   ret i;
}

template<class C>
inline void copyarray(C const * a, u_int j, C * const b)
{
  for(u_int i=0;i<j;i++) b[i]=a[i];
}

template<class C>
inline C* copyarray(C const * a, u_int j)
{ C *r=new C[j];
  copyarray(a,j,r);

  return r;
}

template<class C>
inline int diffarray(C *a, C *b,u_int j)
{ 
  for(u_int i=0;i<j;i++)
  { 
    if(a[i]<b[i]) ret -1;
    if(a[i]>b[i]) ret 1;
  }
  return 0;
}

template<class C>
inline bool cmparray(C *a, C *b,u_int j)
{ 
  for(u_int i=0;i<j;i++)
    if(a[i]!=b[i]) return false;

  return true;
}

template<class C>
inline u_int member(C a,C *b,u_int j)
{
  for(u_int i=0;i<j;)
    if(b[i++]==a) return i;

  return 0;
}

// void bzero(char *b,int length);


template<class C>
inline void zeroarray(C *sp, u_int ne){
  // bzero((char *)sp, sizeof(C)*ne);
  for(u_int i=0;i<ne;)
  sp[i++]=0;
}

inline int pow(int n, int c)
{
  if(c<0)
  {
    if(abs(n)>1) {
      cerr<<"pow: tried to inverse non-unit integer"<<endl;
      ret 1;
    }
    ret pow(n,-c);
  }

  int k=0,s=1;
  for(;k<c;s*=n,k++);
  ret s;
}


template<class C>
void qsort(C *a, int len)
{
  if(len<1) ret;

  C *x=new C[len],*b=new C[len],v=a[len/2];
  int c=0,d=0,i;

  if(x==0 || b==0) // no memory - bubblesort
  {
    for(c=0;c<len;c++) for(d=c+1;d<len;++d)
    if(a[c]>a[d]) swap(a[c],a[d]); 
    delete [] x,b;
    ret;
  }

  for(i=0;i<len;i++)
  {
    if(i==len/2) cont;
    if(a[i]<v) x[c++]=a[i];
    else b[d++]=a[i];
  }
  qsort(x,c);
  qsort(b,d);
  copyarray(x,c,a);
  copyarray(b,d,a+c+1);
  a[c]=v;

  delete [] x,b;
}

// ret 1+index of 1st occurence of e in a, else 0
template<class C> 
int qmember(C e, C *a, int len) {
  if(1>len) ret 0;

  register int b,i=len/2;

  C x=a[i];

  if(x<e) {
    b=qmember(e,a+i+1,len-i-1);
    ret b?b+i+1:0;
  }
  if(x>e) ret qmember(e,a,i);
  while(i-- && a[i]==e); ret i+2;
}

#endif

