
#include "mydefs.h"
#include <stdio.h>

int *a=0,*w=0,*o=0,cr,nr,writhe(int *);
// Dowker code array, crsg nr, diagram nr

bool next()
{
  int i;

  delete [] a,o,w;

  cin>>cr>>nr;


  if(!cin) ret false;

  a=new int[cr];
  o=new int[2*cr];
  w=new int[2*cr];

  for(i=0;i<cr;i++) cin >> a[i];

  for(i=0;i<2*cr;i++) 
  {
    if(i%2) o[i]= a[i/2];

    int j;

    for(j=0;j<cr;j++)
      if(abs(a[j])%(2*cr)==i) o[i]= -(1+2*j)*sgn(a[j]);
  }

  // outputarray(cerr,w,2*cr);
  writhe(w);
  // for(i=0;i<cr;cerr<<w[2*i++ +1]<<" ");

  ret cin;
}

inline int othcrs(int i)
{
  (i=(2*cr+i%(2*cr))%(2*cr)); // || (i=2*cr);
  // make i betw 1 and 2*cr
  ret o[i];
}


inline bool linked(int i, int j)
{
  int m=max(j,abs(othcrs(j))),
      n=min(j,abs(othcrs(j))),
      o=max(i,abs(othcrs(i))),
      p=min(i,abs(othcrs(i)));

  ret (o-m)*(p-n)*(m-p)*(o-n)>0;
}

#define betw(c,a,b) ((c)-(a))*((b)-(c))*((b)-(a))>0
// c betw a & b in cycl order 1,2,...,2*cr,1
// e.g. 10 is betw 9 and 1

#define j_in_i_minus(i,j) (othcrs(i)<0?betw(j,-othcrs(i),i):betw(j,i,othcrs(i)))


inline bool nlinked_p_m(int i, int j)
{
  ret !linked(i,j) && j_in_i_minus(i,j) && !j_in_i_minus(j,i); 
}

int writhe(int *w)
{

#define SO(i) sgn(othcrs(i))
#define AO(i) abs(othcrs(i))
#define W(i) w[(i)%(2*cr)]
#define B(i) b[(i)%(2*cr)]

  int i,l,j,s,k,wa=0,q,nw;
  // writhe of altern diag, and of single crsgs
  // nw = new writhe computed in iteration ? ->
  // check again; else all writhes computed

  // int b[2*cr];
  // for(i=0;i<2*cr;i++) { a[i]*=(B(AO(1+2*i))=b[1+2*i]=sgn(a[i])); }

  zeroarray(w,2*cr);
  for(q=1; q<2*cr; q+=2) { if(w[q]) cont;

  w[q]=W(AO(q))=1; // set crsg (q,AO(q)) positive

 do
 { nw=0;

   for(i=q;i<=2*cr;i++) 
   for(l=q;l<=2*cr;l++) 
   if(W(i) && !W(l) && linked(i,l))
// find an undone crsg l linked with a done one i
   {  nw=1;
      // TRC("---------------------");
      // TRC(i);
      // TRC(l);
      j=betw(l,i,AO(i)) ? l : AO(l);
      // TRC(j);
// take preimage of l betw i & AO(i)
      s=(j-i)%2 ? 1 : -1;
      // TRC(s);
// by this sign w[j] differs from w[i] if loop
// betw AO(i) & i enters loop betw i & AO(i) first
// time at (l,AO(l)); need to correct this by
// the parity of entries/exits

      for(k=AO(i)%(2*cr)+1;
               betw(k,AO(i),AO(j));
               k=k%(2*cr)+1)
// run through loop from AO(i) until coming to (l,AO(l))
      {
	  // TRC(k);
	  // TRC(AO(k));
          if(betw(AO(k),i,AO(i))) { s=-s; } // TRC(k); 
// count parity of entries/exits of interior of loop
// betw i & AO(i)
      }

// count self-crsgs of loop from i to AO(i) until j comes
      for(k=i%(2*cr)+1; betw(k,i,j); k=k%(2*cr)+1)
      {
          if(betw(AO(k),i,AO(i))) { s=-s; } // TRC(k);
      }
      // TRC(s);

      W(AO(j))=W(j)=s*W(i);
      // TRC(W(i));
      // TRC(W(j));
      
   }


 } while(nw);
// no pair (i,l) found - done

} // while(q);

  for(i=0;i<cr;i++) { wa+=(W(AO(2*i+1))=w[2*i+1]*=sgn(a[i])); }

  ret wa;

}

int g1()
{
  int w[2*cr];
  ret writhe(w);
}

int v2()
{
   int i,j,s;
   

   for(s=0,i=1;i<2*cr;i+=2)
     for(j=i+2;j<2*cr;j+=2)
       if(linked(i,j)
	  && sgn(othcrs(i))*sgn(abs(othcrs(i))-i)*
	     sgn(othcrs(j))*sgn(abs(othcrs(j))-j) == -1
	     ) s+=(w[i]*w[j]);
   ret s/2;
}

int g2()
{
   int i,j,s;
   

   for(s=i=0;i<cr;i++)
     for(j=i+1;j<cr;j++)
       if(linked(2*i+1,2*j+1)) s+=(w[2*i+1]+w[2*j+1]);
   ret s/2;
}

int g2_1()
{
   int i,j,s;

   for(s=i=0;i<cr;i++)
     for(j=i+1;j<cr;j++)
       if(linked(2*i+1,2*j+1)) s++;
   ret s;
}

int g3_1a()
{
   int i,j,k,s;
   

   for(s=i=0;i<cr;i++)
     for(j=i+1;j<cr;j++)
       for(k=j+1;k<cr;k++)
         if(linked(2*i+1,2*j+1) &&
	    linked(2*i+1,2*k+1) &&
	    linked(2*k+1,2*j+1) ) s++;
   ret s;
}

int g3_1()
{
   int i,j,k,s;
   

   for(s=i=0;i<cr;i++)
     for(j=i+1;j<cr;j++)
       for(k=j+1;k<cr;k++)
         if(linked(2*i+1,2*j+1) &&
	    linked(2*i+1,2*k+1) &&
	    linked(2*k+1,2*j+1) ) s+=(w[2*i+1]+w[2*j+1]+w[2*k+1]);
   ret s;
}

int g3_2()
{
   int i,j,k,s;
   

   for(s=i=0;i<cr;i++)
     for(j=i+1;j<cr;j++)
       for(k=j+1;k<cr;k++)
         if(linked(2*i+1,2*j+1) &&
	    linked(2*i+1,2*k+1) &&
	    linked(2*k+1,2*j+1) ) s+=(w[2*i+1]*w[2*j+1]*w[2*k+1]);
   ret s;
}

int g3_31()
{
   int i,j,k,s;
   for(s=i=0;i<cr;i++)
     for(j=0;j<cr;j++)
       for(k=0;k<cr;k++)
         if(linked(2*i+1,2*j+1) &&
	    linked(2*i+1,2*k+1) &&
	    nlinked_p_m(2*k+1,2*j+1) ) s+=(w[2*i+1]*w[2*j+1]*w[2*k+1]);
   ret s;
}

int g3_3()
{
   int i,j,k,s;
   

   for(s=i=0;i<cr;i++)
     for(j=0;j<cr;j++)
       for(k=j+1;k<cr;k++)
         if(linked(2*i+1,2*j+1) &&
	    linked(2*i+1,2*k+1) &&
	    !linked(2*k+1,2*j+1) ) s+=(w[2*i+1]*w[2*j+1]*w[2*k+1]);
   ret s;
}

inline int v3() { ret (g3_31()+g2()+g3_2())/4; }

int g3_4()
{
   int i,j,k,s;
   

   for(s=i=0;i<cr;i++)
     for(j=0;j<cr;j++)
       for(k=j+1;k<cr;k++)
         if(linked(2*i+1,2*j+1) &&
	    linked(2*i+1,2*k+1) &&
	    !linked(2*k+1,2*j+1) ) s+=(w[2*i+1]+w[2*j+1]+w[2*k+1]);
   ret s;
}

main()
{

  while(next())
  {
    // TRC(nr);
#define F(a) <<" "<<form("%5d",a)
#define FS(a) <<" "<<form("%5d",sgn(g1())*a)

    // cout F(cr) F( nr ) F( g2_1() ) F( g3_1a() ) FS( g1() ) FS( g2() ) FS( g3_1() ) FS( g3_2() ) FS( g3_3() ) FS( g3_4()) << endl;
    cout  F(cr) F(nr) F ( v2() ) F( v3() ) << endl;
    // cout  F(cr) F(nr) F( g1() ) F( g2_1() ) F ( v2() )<< endl;
  }
}
